{                         FPKPascal Runtime-Library                         }
{                             Linux Unit for Linux                          }
{                         Michael Van Canneyt, 1996                         }

Unit Linux;

Interface

{ We should get rid of this, or at least get it into implementation }
Uses Strings,syscalls;

Type pglob = ^tglob;
     tglob = record
       name : pchar;
       next : pglob
       end;
       
     pathstr = string[255];

{$Packrecords 1}
      SignalHandler   = Procedure ( Sig : Integer );
      PSignalHandler  = ^SignalHandler;
      SignalRestorer  = Procedure;
      PSignalRestorer = ^SignalRestorer;

      SigActionRec = record
        Sa_Handler : ^SignalHandler;
        Sa_Mask : longint;
        Sa_Flags : Integer;
        Sa_restorer : ^SignalRestorer; { Obsolete - Don't use }
      end;
      PSigActionRec = ^SigActionRec;

     SigSet  = Integer;
     PSigSet = ^SigSet;


var LinuxError : Longint;
    StdErr     : Text;
    
Const { For getting/setting priority }
      Prio_Process = 0;
      Prio_PGrp    = 1;
      Prio_User    = 2;
      { For testing  access rights }
      R_OK = 4; 
      W_OK = 2;
      X_OK = 1;
      F_OK = 0;
      { For sending a signal }
      SA_NOCLDSTOP = 1;
      SA_SHIRQ	   = $04000000;
      SA_STACK	   = $08000000;      
      SA_RESTART   = $10000000;
      SA_INTERRUPT = $20000000;
      SA_NOMASK	   = $40000000;
      SA_ONESHOT   = $80000000;
      
      SIG_BLOCK	  = 0;
      SIG_UNBLOCK = 1;
      SIG_SETMASK = 2;

      SIG_DFL = 0 ;
      SIG_IGN = 1 ;
      SIG_ERR = -1 ;
      
      SIGHUP		= 1;
      SIGINT		= 2;
      SIGQUIT		= 3;
      SIGILL		= 4;
      SIGTRAP		= 5;
      SIGABRT		= 6;
      SIGIOT		= 6;
      SIGBUS		= 7;
      SIGFPE		= 8;
      SIGKILL		= 9;
      SIGUSR1		= 10;
      SIGSEGV		= 11;
      SIGUSR2		= 12;
      SIGPIPE		= 13;
      SIGALRM		= 14;
      SIGTERM		= 15;
      SIGSTKFLT		= 16;
      SIGCHLD		= 17;
      SIGCONT		= 18;
      SIGSTOP		= 19;
      SIGTSTP		= 20;
      SIGTTIN		= 21;
      SIGTTOU		= 22;
      SIGURG		= 23;
      SIGXCPU		= 24;
      SIGXFSZ		= 25;
      SIGVTALRM		= 26;
      SIGPROF		= 27;
      SIGWINCH		= 28;
      SIGIO		= 29;
      SIGPOLL		= SIGIO;
      SIGPWR		= 30;
      SIGUNUSED		= 31;

      { For File control mechanism }
      F_GetFd  = 1;
      F_SetFd  = 2;
      F_GetFl  = 3;
      F_SetFl  = 4;
      F_GetLk  = 5;
      F_SetLk  = 6;
      F_SetLkW = 7;
      F_GetOwn = 8;
      F_SetOwn = 9;

{ Time functions }

Function  GetEpochTime : longint;
Procedure EpochToLocal (epoch : longint; var year,month,day,hour,minute,second : Integer);
Procedure GetTime (Var Hour, Minute, Second : Integer);
Procedure GetDate (Var Year, Month, Day : Integer);

{ Process Handling }
            
Procedure Execve ( Path : pathstr; args : ppchar; ep : ppchar );
Procedure execv ( path : pathstr; args : ppchar);
Procedure Execvp ( Path : Pathstr; Args : ppchar; Ep : ppchar );
Procedure Execl (Todo : string);
Procedure Execle (Todo : string; Ep : ppchar);
Procedure Execlp (Todo : string; Ep : ppchar);
Function  Shell ( Command : String) : Longint;
Function  Fork : longint;
Function  WaitPid (Pid : longint; Status : pointer; Options : Integer) : Longint;
Procedure Nice (N : integer);
Function  GetPriority ( Which : Integer; Who : Integer) : integer;
Procedure SetPriority ( Which : Integer; Who : Integer; What : Integer);
Function  GetPid : LongInt;
Function  GetPPid : LongInt;
Function  GetUid : Longint;
Function  GetEUid : Longint;
Function  GetGid : Longint;
Function  GetEGid : Longint;

{ File and I/O handling }

Procedure Link ( OldPath, NewPath : pathstr);
Procedure SymLink ( OldPath, NewPath : pathstr);
Procedure UnLink ( Path : pathstr);
Procedure Chown (path : pathstr; NewUid,NewGid : longint);
Procedure Chmod (path : pathstr; Newmode : longint);
Function  Access ( Path : Pathstr ; mode : integer) : boolean;
Function  Umask ( Mask : Integer ) : integer;
Procedure FStat (Path : Pathstr; Var Info : stat);
Procedure FSStat (Path : Pathstr; Var Info : statfs);
Function  FExpand(Const Path: PathStr): PathStr;
Function  FSearch(path : pathstr;dirlist : string) : pathstr;
Function  Dirname ( const path : pathstr ) : pathstr;
Function  Basename ( const path : pathstr; const suf : pathstr) : pathstr;
Function  Glob (const path : pathstr) : pglob;
Procedure Globfree ( var p : pglob );
Procedure AssignPipe (var pipe_in, pipe_out : text);
Procedure POpen ( var F : text; Prog : String; rw : char );
Function  Fcntl ( Fd : Text; Cmd : Integer) : integer;
Procedure Fcntl ( Fd : Text; Cmd : Integer; Arg : Longint);
Procedure Dup ( var oldfile,newfile : text );
Procedure Dup2 ( var oldfile,newfile : text );

{ Signal Handling }

Procedure SigAction (Signum : Integer; Var Act,OldAct : PSigActionRec  );
Procedure SigProcMask  (How : Integer; SSet,OldSSet : PSigSet);
Function  SigPending : SigSet;
Procedure SigSuspend (Mask : Sigset);
Function  Signal (Signum : Integer; Handler : PSignalHandler) : PSignalHandler;
Function  Kill ( Pid : longint; Sig : integer) : integer;

{ General functions }

Function  GetDomainName : String;
Function  GetHostName : String;
Function  GetEnv(P : string): Pchar;
Function  StringToPPChar ( Var S : STring ) : ppchar;


Implementation

Const P_IN  = 1;
      P_OUT = 2;


type
  TextBuf = array[0..127] of char;


  TextRec = record
    handle : word;
    mode : word;
    bufSize : word;
    _private : word;
    bufpos : word;
    bufend : word;
    bufptr : ^textbuf;
    openfunc : pointer;
    inoutfunc : pointer;
    flushfunc : pointer;
    closefunc : pointer;
    userdata : array[1..16] of byte;
    name : array[0..255] of char;
    buffer : textbuf;
    End;

var OldExitProc : pointer;    
    { These are needed for the time functions. 
      Making them local variables gives errors. }
     t : time;
     tz : timezone;

Procedure execve ( path : pathstr; args : ppchar; ep : ppchar );

{
  Replaces the current program by the program specified in path,
  arguments in args are passed to execve.
  environment specified in ep is passed on.
}

begin
  path:=path+#0;
  sys_execve (@(path[1]),args,ep);
  { This only gets set when the call fails, otherwise we don't get here ! }
  Linuxerror:=errno
end;

Procedure execv ( path : pathstr; args : ppchar );

{
  Replaces the current program by the program specified in path,
  arguments in args are passed to execve.
  the current environment is passed on.
}

begin
  path:=path+#0;
  sys_execve (@(path[1]),args,envp);
  { This only gets set when the call fails, otherwise we don't get here ! }
  Linuxerror:=errno
end;

Procedure Execvp ( Path : Pathstr; Args : ppchar; Ep : ppchar );

{ This does the same as execve, only it searches the PATH environment
  for the place of the executable, except when Path starts with a slash.
  if the PATH environment variable is unavailable, the path is set to '.' 
}

var thepath,theexec : string;

begin
  if path[1]<>'/' then 
     begin
     Thepath:=strpas(getenv ('PATH'));
     if thepath='' then thepath:='.';
     theexec:=fsearch (path,thepath)
     end
  else
     theexec:=path;
  if theexec='' then
     linuxerror:=sys_enoent
  else 
    execve(theexec,args,ep); {On error linuxerror will get set there}
end;

Function StringToPPChar ( Var S : STring ) : ppchar;

var i,nr : integer;
    Buf  : Pchar;
    p    : ppchar;

begin
  nr:=0;
  i:=0;
  S:=S+#0;
  buf:=@S[1];
  while (buf^<>#0) do
    begin
    while ((buf^=' ') or (buf^=#8)) or (buf^=#10) do buf:=buf+1;
    inc(nr);
    while not (    ((buf^=' ') or (buf^=#8)) 
                or ((buf^=#10) or (buf^=#0))
              ) do buf:=buf+1;
    end;
  getmem(p,nr*4);
  if p=nil then
     begin
     StringToPPChar:=nil;
     LinuxError:=sys_enomem;
     exit
     end; 
  i:=0;
  buf:=@(S[1]);
  StringToPPchar:=p; {save p}
  while buf^<>#0 do
    begin
    while ((buf^=' ') or (buf^=#8)) or (buf^=#10) do 
       begin
       buf^:=#0;
       buf:=buf+1
       end;
    p^:=buf;
    p:=p+4; 
    while not (   ((buf^=' ') or (buf^=#8)) 
               or ((buf^=#10) or (buf^=#0))
              ) do buf:=buf+1;
    end;
 end;

Procedure Execl (Todo : string);

{ This procedure takes the string 'Todo', parses it for command and 
  command options, and executes the command with the given options.
  The string 'Todo' shoud be of the form 'command options', options 
  separated by commas.
  the PATH environment is not searched for 'command'.
  The current environment is passed on to command }

var p : ppchar;

begin
  p:=StringToPPchar (todo);
  if p=nil then exit;
  if p^=nil then exit;
  sys_execve (p^,p,envp);
end;

Procedure Execle (Todo : string; Ep : ppchar);

{ This procedure takes the string 'Todo', parses it for command and 
  command options, and executes the command with the given options.
  The string 'Todo' shoud be of the form 'command options', options 
  separated by commas.
  the PATH environment is not searched for 'command'.
  The specified environment (in 'ep') is passed on to command }

var p : ppchar;
    thepath,theexec : string;

begin
  p:=StringToPPchar (todo);
  if p=nil then exit;
  if p^=nil then exit;
  if p^^<>'/' then 
     begin
     Thepath:=strpas(getenv ('PATH'));
     if thepath='' then thepath:='.';
     theexec:=fsearch (strpas(p^),thepath)
     end
  else
     theexec:=strpas(p^);
  if theexec='' then
     linuxerror:=sys_enoent
  else 
  sys_execve (@(theexec[1]),p,ep)
end;

Procedure Execlp (Todo : string; Ep : ppchar);

{ This procedure takes the string 'Todo', parses it for command and 
  command options, and executes the command with the given options.
  The string 'Todo' shoud be of the form 'command options', options 
  separated by commas.
  the PATH environment is searched for 'command'.
  The specified environment (in 'ep') is passed on to command }

var p : ppchar;

begin
  p:=StringToPPchar (todo);
  if p=nil then exit;
  if p^=nil then exit;
  execvp (strpas(p^),p,ep);
end;

Function WaitPid (Pid : longint; Status : pointer; Options : Integer) : Longint;

{ Waits until a child with PID Pid exits, or returns if it is exited already.
  Any resources used by the child are freed.
  The exit status is reported in the adress referred to by Status. It should
  be a longint.
}

begin
   WaitPiD:=sys_waitpid (pid,status,options);
   LinuxError:=errno;
end;

Function Shell ( Command : String) : Longint;

{
  Executes the shell, and passes it the string Command. (Through /bin/sh -c)
  The current environment is passed to the shell.
  It waits for the shell to exit, and returns its exit status.
  If the exec call failed exit status 127 is reported.
}

var p,pp : ppchar;
    sh : string[12];
    temp,pid : longint;

begin
  sh:='/bin/sh'#0'-c'#0;
  Command:=Command+#0;
  getmem (pp,12);
  if pp=nil then
     begin
     LinuxError:=sys_enomem;  
     exit
     end;
  pp^:=@sh[1];
  p:=pp+4;
  p^:=@sh[9];
  p:=p+4;
  p^:=@command[1];
  pid:=fork;
  if pid=-1 then exit;  {Linuxerror already set in Fork}
  if pid=0 then
     begin
     {This is the child.}
     execve ('/bin/sh',pp,envp);
     exit (127)
     end;
  temp:=0;
  WaitPid (pid,@temp,0); {Linuxerror is set there}
  Shell:=temp { Return exit status }
end;

Function GetEpochTime : longint;

{
  Get the number of seconds since 00:00, January 1 1970, GMT
  the time is corrected according to the time zone, but NOT
  DST corrected.
}

{
var  t : time ;
    tz : timezone ;
}

begin
  linuxerror:=0;
  sys_gettimeofday (t,tz);
  linuxerror:=errno;
  Getepochtime:=t.sec-tz.minuteswest*60;
  linuxerror:=errno
end;

Procedure EpochToLocal (epoch : longint; var year,month,day,hour,minute,second : Integer);

{
  Transforms Epoch time (seconds since 00:00, january 1 1970, corrected for
  local time zone) into local time (hour, minute,seconds) 
}

Const
  C1970 = 2440588;
  D0    =    1461;
  D1    =  146097;
  D2    = 1721119;

Var
  DateNum: LongInt;

 Procedure JulianToGregorian
           (JulianDN: LongInt; 
            Var Year, Month, Day: Integer);
   
 Var
   Temp,XYear        : LongInt;
   YYear,YMonth,YDay : Integer;
                       
  Begin
   Temp := (((JulianDN - D2) shl 2) - 1);
   XYear := (Temp Mod D1) or 3;
   JulianDN := Temp Div D1;
   YYear := (XYear Div D0);
   Temp := ((((XYear mod D0) + 4) shr 2) * 5) - 3;
   YMonth := Temp Div 153;
   If YMonth >= 10 Then
     Begin
     YYear := YYear + 1;
     YMonth := YMonth - 12;
     End;
   YMonth := YMonth + 3;
   YDay := Temp Mod 153;
   YDay := (YDay + 5) Div 5;
   Year := YYear + (JulianDN * 100);
   Month := YMonth;
   Day := YDay;
  end;
      
Begin { Beginning of Localtime }
  Datenum := (Epoch Div 86400) + c1970;
  JulianToGregorian(DateNum, Year, Month,day);
  Epoch := Epoch Mod 86400;
  Hour := Epoch Div 3600;
  Epoch := Epoch Mod 3600;
  Minute := Epoch Div 60;
  Second := Epoch Mod 60;
End;
                            
Procedure GetTime (Var Hour, Minute, Second : Integer);

{ 
  Gets the current time, adjusted to local time, but not DST,
  in hours, minutes and seconds.
}

var year,day,month : Integer;

Begin
  EpochToLocal(Getepochtime,year,month,day,hour,minute,second)
End;

Procedure GetDate (Var Year,Month,Day : Integer);

{ 
  Gets the current date, adjusted to local time, but not DST,
  in year,month,day.
}

var hour,minute,second : Integer;

Begin
  EpochToLocal(Getepochtime,year,month,day,hour,minute,second)
End;


Function GetEnv(P : string): Pchar;

{ 
  Searches the environment for a string with name p and 
  returns a pchar to it's value.
  A pchar is used to accomodate for strings of length > 255
}

var 
    ep : ppchar;
    gotit : boolean;
    l : byte;

  Begin
  ep:=envp;
  l:=length(p);
  gotit:=false;
  while (ep^<>nil) and not gotit do 
     if strlcomp(@p[1],ep^,l)=0 then
        gotit:=true
     else
        ep:=ep+4;
  if gotit then
     getenv:=ep^+l+1
  else
     getenv:=nil
  End;

Procedure Chmod (path : pathstr; Newmode : longint);

{
  Changes the permissions of a file.
}

var sr : syscallregs;

begin
  path:=path+#0;
  sr.ebx:=longint(@(path[1]));
  sr.ecx:=newmode;
  if syscall (syscall_nr_chmod,sr) <0 then 
     linuxerror:=errno
  else
     linuxerror:=0;
end;

Procedure Chown (path : pathstr; NewUid,NewGid : longint);

{
  Change the owner and group of a file. 
  A user can only change the group to a group of which he is a member.
  The super-user can change uid and gid of any file.
}

var sr : syscallregs;

begin
  path:=path+#0;
  sr.ebx:=longint(@(path[1]));
  sr.ecx:=newuid;
  sr.edx:=newgid;
  if syscall (syscall_nr_chown,sr) <0 then 
     linuxerror:=errno
  else
     linuxerror:=0;
end;

Procedure FStat (Path : Pathstr; Var Info : stat);
{
Get all information on a file, and return it in Info.
}

begin
  path:=path+#0;
  if sys_stat (@(path[1]),Info)<0 then 
     LinuxError:=errno
  else
     Linuxerror:=0
end;

Procedure FSStat (Path : Pathstr; Var Info : statfs);
{
Get all information on a filesystem, and return it in Info.
Path is the name of a file/directory on the filesystem you wish to 
investigate.
}

begin
  path:=path+#0;
  if sys_statfs (@(path[1]),Info)<0 then 
     LinuxError:=errno
  else
     Linuxerror:=0
end;

Function GetPid : LongInt;

{
 Get Process ID.
 }
begin
 GetPid:=Sys_GetPid;
 linuxerror:=errno;
end;

Function GetPPid : LongInt;

{
 Get Process ID of parent process.
}
begin
  GetPPid:=Sys_getPPid;
  linuxerror:=errno
end;

Function GetUid : Longint;

{
  Get User ID.
}

Begin
  GetUid:=Sys_GetUid;
  Linuxerror:=errno
end;

Function GetEUid : Longint;

{
  Get _effective_ User ID.
}

Begin
  GetEUid:=Sys_GetEUid;
  Linuxerror:=errno
end;

Function GetGid : Longint;

{
  Get Group ID.
}

Begin
  GetGid:=Sys_GetGid;
  Linuxerror:=errno
end;

Function GetEGid : Longint;

{
  Get _effective_ Group ID.
}

Begin
  GetEGid:=Sys_GetEGid;
  Linuxerror:=errno
end;


Function GetDomainName : String;

{
  Get machines domain name. Returns empty string if not set.
}

Var  sysn : utsname; 

begin
  if sys_uname (sysn)<0 then 
     begin
     getdomainname:='';
     linuxerror:=errno
     end
  else
     begin
     getdomainname:=strpas (@(sysn.domainname[0]));
     linuxerror:=0
     end
end;

Function GetHostName : String;

{
  Get machines name. Returns empty string if not set.
}

Var sysn : utsname;

begin
  if sys_uname (sysn)<0 then 
     begin
     gethostname:='';
     linuxerror:=errno
     end
  else
     begin
     gethostname:=strpas (@(sysn.nodename[0]));
     linuxerror:=0
     end
end;

Function GetPriority ( Which : Integer; Who : Integer) : integer;

{
 Get Priority of process, process group, or user.
   Which : selects what kind of priority is used.
           can be one of the following predefined constants : 
              Prio_User.
              Prio_PGrp.
              Prio_Process.
   Who : depending on which, this is , respectively :
              Uid
              Pid
              Process Group id
   Errors are reported in linuxerror _only_. (priority can be negative) 
}

var sr : syscallregs;

begin
  errno:=0;
  if (which<prio_process) or (which>prio_user) then
     begin
     { We can save an interrupt here }
     getpriority:=0;
     linuxerror:=sys_einval;
     end
  else
     begin
     sr.ebx:=which;
     sr.ecx:=who;
     getpriority:=syscall (syscall_nr_getpriority,sr);
     linuxerror:=errno
     end;
end;

Procedure SetPriority ( Which : Integer; Who : Integer; What : Integer);

{
 Set Priority of process, process group, or user.
   Which : selects what kind of priority is used.
           can be one of the following predefined constants : 
              Prio_User.
              Prio_PGrp.
              Prio_Process.
   Who : depending on value of which, this is, respectively :
              Uid
              Pid
              Process Group id
   what : A number between -20 and 20. -20 is most favorable, 20 least.
          0 is the default.
}

var sr : syscallregs;

begin
  errno:=0;
  if ((which<prio_process) or (which>prio_user)) 
      or ((what<-20) or (what>20))  then
     begin
     { We can save an interrupt here }
     linuxerror:=sys_einval;
     end
  else
     begin
     sr.ebx:=which;
     sr.ecx:=who;
     sr.edx:=what;
     syscall (syscall_nr_setpriority,sr);
     linuxerror:=errno
     end;
end;

Procedure Nice (N : integer);

{
  Set process priority. A positive N means a lower priority.
  A negative N decreases priority.
}

var sr : syscallregs;

begin
  sr.ebx:=n;
  if syscall (syscall_nr_nice,sr) < 0 then 
     linuxerror:=errno
  else
     linuxerror:=0;
end;

Procedure Link ( OldPath, NewPath : pathstr);

{
 Proceduces a hard link from new to old.
 In effect, new will be the same file as old.
}

begin
  oldpath:=oldpath+#0;
  newpath:=newpath+#0;
  sys_link (pchar(@(oldpath[1])) ,pchar(@(newpath[1])) );
  linuxerror:=errno
end;

Procedure SymLink ( OldPath, newPath : pathstr);

{
 Proceduces a soft link from new to old.
}

begin
  oldpath:=oldpath+#0;
  newpath:=newpath+#0;
  sys_symlink (pchar(@(oldpath[1])) ,pchar(@(newpath[1])) );
  linuxerror:=errno
end;

Procedure UnLink ( Path : pathstr);

{
 Removes the file in 'Path' (that is, it decreases the link count with one. 
 if the link count is zero, the file is removed from the disk.
}

begin
  path:=path+#0;
  sys_unlink (pchar(@(path[1])) );
  linuxerror:=errno
end;




Function Kill ( Pid : longint; Sig : integer) : integer;

{
  Send signal 'sig' to a process, or a group of processes.
  If Pid >  0 then the signal is sent to pid
     pid = -1                         to all processes except process 1
     pid < -1                         to process group -pid
  Return value is zero, except for case three, where the return value
  is the number of processes to which the signal was sent.
 }

var sr : syscallregs;  
  
begin
  sr.ebx:=Pid;
  sr.ecx:=Sig;
  linuxerror:=syscall (syscall_nr_kill,sr);
  if linuxerror>0 then
     begin
     kill:=linuxerror;
     linuxerror:=0
     end
  else
     begin
     kill:=0;
     if linuxerror=-1 then 
        linuxerror:=errno
     end
end;


Procedure SigAction (Signum : Integer; Var Act,OldAct : PSigActionRec  );

{
  Change action of process upon receipt of a signal.
   Signum specifies the signal (all except SigKill and SigStop).
   If Act is non-nil, it is used to specify the new action.
   If OldAct is non-nil the previous action is saved there.
}
Var sr : syscallregs;

begin
  sr.ebx:=Signum;
  sr.ecx:=Longint(act);
  sr.edx:=Longint(oldact);
  if syscall (syscall_nr_sigaction,sr)=-1 then
     linuxerror:=errno
  else
     linuxerror:=0;
end;

Procedure SigProcMask  (How : Integer; SSet,OldSSet : PSigSet);

{
 Change the list of currently blocked signals.
  How determines which signals will be blocked :
   SigBlock   : Add SSet to the current list of blocked signals
   SigUnBlock : Remove the signals in SSet from the list of blocked signals.
   SigSetMask : Set the list of blocked signals to SSet
  if OldSSet is non-null, the old set will be saved there.
}
Var sr : SyscallRegs;

begin
  sr.ebx:=how;
  sr.ecx:=longint(SSet);
  sr.edx:=longint(OldSSet);
  if syscall (syscall_nr_sigprocmask,sr)=-1 then
     linuxerror:=errno
  else
     linuxerror:=0;
end;

Function SigPending : SigSet;

{
  Allows examination of pending signals. The signal mask of pending
  signals is set in SSet
}

Var sr    : SyscallRegs;
    dummy : Sigset;

begin
  sr.ebx:=longint(@dummy);
  if syscall (syscall_nr_sigpending,sr)=-1 then
     linuxerror :=errno
  else
     Linuxerror:=0;
  Sigpending := dummy
end;

Procedure SigSuspend (Mask : Sigset);

{
 Set the signal mask with Mask, and suspend the program until a signal
 is received.
}

Var sr : SyscallRegs;

begin
  sr.ebx:=mask;
  if syscall (syscall_nr_sigsuspend,sr)=-1 then
     linuxerror:=errno
  else
     linuxerror:=0;
end;

Function Signal (Signum : Integer; Handler : PSignalHandler) : PSignalHandler;

{
  Install a new handler for signal Signum.
  The old signal handler is returned.
  This call does, in fact, the same as SigAction.
}

var sr : syscallregs;

begin
  sr.ebx:=signum;
  sr.ecx:=longint(handler);
  Linuxerror:=syscall (syscall_nr_signal,sr);
  If linuxerror=Sig_Err then
     begin
     Signal := nil;
     Linuxerror:=errno
     end
  else
     begin
     Signal:=pointer(Linuxerror);
     linuxerror:=0
     end
end;


Function Umask ( Mask : Integer ) : integer;

{
  Sets file creation mask to (Mask and 0777 (octal) ), and returns the
  previous value.
}

var sr : syscallregs;

begin
  sr.ebx:=mask;
  Umask:=syscall (syscall_nr_umask,sr);
  linuxerror:=0;
end;

Function Access ( Path : Pathstr ; mode : integer) : boolean;

{
  Test users access rights on the specified file.
  Mode is a mask xosisting of one or more of R_OK, W_OK, X_OK, F_OK.
  R,W,X stand for read,write and execute access, simultaneously.
  F_OK checks whether the test would be allowed on the file.
  i.e. It checks the search permissions in all directory components 
  of the path.
  The test is done with the real user-ID, instead of the effective.
  If access is denied, or an error occurred, false is returned. 
  If access is granted, true is returned. 
  Errors other than no access,are reported in linuxerror.
}

var sr : syscallregs;

begin
  path:=path+#0;
  sr.ebx:=longint(@(path[1]));
  sr.ecx:=mode;
  linuxerror:=0;
  if syscall (syscall_nr_access, sr) <0 then
     begin
     if errno<>sys_eacces then linuxerror:=errno;
     access:=false
     end
  else    
     access:=true;     
end;

Procedure Dup ( var oldfile,newfile : text );

{
  Copies the filedescriptor oldfile to newfile, after flushing the buffer of
  oldfile.
  After which the two textfiles are, in effect, the same, except
  that they don't share the same buffer, and don't share the same
  close_on_exit flag. 
}

var sr : syscallregs;

begin
 flush(oldfile); { We cannot share buffers, so we flush them. }
 textrec(newfile):=textrec(oldfile);
 textrec(newfile).bufptr:=@(textrec(newfile).buffer); { No shared buffer. }
 sr.ebx:=textrec(oldfile).handle;
 textrec(newfile).handle:=syscall (syscall_nr_dup,sr);
 if textrec(newfile).handle<0 then
    linuxerror:=errno
 else
    linuxerror:=0
end;

Procedure Dup2 ( var oldfile,newfile : text );

{
  Copies the filedescriptor oldfile to newfile, after flushing the buffer of
  oldfile. It closes newfile if it was still open.
  After which the two textfiles are, in effect, the same, except
  that they don't share the same buffer, and don't share the same
  close_on_exit flag. 
}

var sr : syscallregs;
    tmphandle : word;
    
begin
 flush (oldfile); { We cannot share buffers, so we flush them. }
 flush (newfile);
 tmphandle:=textrec(newfile).handle;
 textrec(newfile):=textrec(oldfile);
 textrec(newfile).handle:=tmphandle;
 textrec(newfile).bufptr:=@(textrec(newfile).buffer); { No shared buffer. }
 sr.ebx:=textrec(oldfile).handle;
 sr.ecx:=textrec(newfile).handle;
 if syscall (syscall_nr_dup2,sr) <0 then
    linuxerror:=errno
 else
    linuxerror:=0
end;

Function Fcntl ( Fd : Text; Cmd : integer) : integer;

{
  Read or manipulate a file. ( See also fcntl (2) )
  Possible values for Cmd are :
    F_GetFd,F_GetFl,F_GetOwn
  Errors are reported in Linuxerror;
  If Cmd is different from the allowed values, linuxerror=sys_eninval.
}

var sr : syscallregs;

begin
  if (cmd=F_getfd) or ((cmd=F_Getfl) or (cmd= F_GetOwn)) then
     begin
     sr.ebx:=textrec(fd).handle;
     sr.ecx:=cmd;
     Linuxerror:=syscall (syscall_nr_fcntl,sr);
     if linuxerror=-1 then
        begin
        linuxerror:=errno;
        fcntl:=0
        end
     else
        begin
        fcntl:=linuxerror;
        linuxerror:=0;
        end;
     end
  else
    begin
    linuxerror:=sys_einval;
    Fcntl:=0;
    end;
end;

Procedure Fcntl ( Fd : Text; Cmd : Integer; Arg : Longint);

{
  Read or manipulate a file. (See also fcntl (2) )
  Possible values for Cmd are :
    F_setFd,F_SetFl,F_GetLk,F_SetLk,F_SetLkW,F_SetOwn;
  Errors are reported in Linuxerror;
  If Cmd is different from the allowed values, linuxerror=sys_eninval.
  F_DupFD is not allowed, due to the structure of Files in Pascal.
}

var sr : syscallregs;

begin
  If ((cmd=F_SetFd) or (cmd=F_Setfl)) or 
     (((cmd=F_GetLk) or (cmd=F_SetLk)) or 
      ((cmd=F_SetLkW) or (cmd=F_SetOwn))) then
     begin
     sr.ebx:=textrec(fd).handle;
     sr.ecx:=cmd;
     sr.edx:=arg;
     If syscall (syscall_nr_fcntl,sr)=-1 then
        linuxerror:=errno
     else
        linuxerror:=0;
     end
  else
    begin
    linuxerror:=sys_einval;
    end;
end;



Function FExpand(Const Path: PathStr): PathStr;

var temp : pathstr;
    i,j    : byte;

  Begin
  { Do we have an absolute path ? No - prefix the current dir }
  i:=1;
  if path[i]<>'/' then 
        getdir (0,temp)
  else
    begin
    inc(i);
    temp:=''
    end;
  temp:=temp+'/'+copy(path,i,length(path)-i+1);
  { First remove all references to '/./'}
  while pos ('/./',temp)<>0 do
     delete (temp,pos('/./',temp),2);
  { Now remove also all references to '/../' + of course previous dirs.. }
  i:=pos('/../',temp);
  while i<>0 do 
    begin
    { Find the pos of the previous dir }
    if i>1 then
       begin
       j:=i-1;
       while (j>1) and (temp[j]<>'/') do dec (j); { temp[1] is always '/' }
       delete (temp,j,i-j+3)
       end 
    else
       { i=1, so we have temp='/../something', just delete '/../' }
       delete (temp,1,3);
    { Compute new i }
    i:=pos('/../',temp);
    end;   
   fexpand:=temp;
  End;



Function  Fsearch(path : pathstr;dirlist : string) : pathstr;

{
 Searches for a file 'path' in the list of direcories in 'dirlist'.
 returns an empty string if not found. Wildcards are NOT allowed.
 If dirlist is empty, it is set to '.'
}

  Var NewDir: PathStr;
    p1: Byte;
    dummy : stat;

  Begin
  If (Pos('?', Path) <> 0) or (Pos('*', Path) <> 0) Then
    FSearch := '' {No wildcards allowed in these things.}
  Else
    Begin
    path:=path+#0;
    if DirList='' then DirList:='.';
    Repeat
      p1 := Pos(':', DirList);
      If p1 > 0 Then
        Begin
        NewDir := Copy(DirList, 1, P1 - 1);
        Delete(DirList, 1, p1)
        End
      Else
        Begin
        NewDir := DirList;
        DirList := ''
        End;
      newdir:=newdir+'/'+path;
      sys_stat (@(newdir[1]), dummy);
      If Errno = 0 Then
        Begin
        NewDir := Fexpand(NewDir);
        If Pos('./', NewDir) = 1 Then 
          Delete(NewDir, 1, 2)
        End
      Else
        NewDir := '';
    Until(DirList = '') or (Length(NewDir) > 0);
    FSearch := NewDir;
    End
  End;
  
Function Fork : longint;

{
  This function issues the 'fork' system call. the program is duplicated in memory
  and execution continues in parent and child process.
  In the parent process, fork returns the PID of the child. In the child process,
  zero is returned.
  A negative value indicates that an error has occurred, the error is returned in
  LinuxError.
}  

begin
  fork:=sys_fork;
  LinuxError:=errno;
end;

Function Dirname ( const path : pathstr ) : pathstr;

{
  This function returns the directory part of a complete path.
  Unless the directory is root '/',  The last character is not
  a slash.
}

var i,j : byte;

begin
  if path='' then
     begin
     dirname:='';
     exit
     end;
  j:=0;
  for i:=1 to length(path) do if path[i]='/' then j:=i;
  if j=0 then 
     dirname:=''
  else
     if j=1 then
        dirname:='/'
     else
        dirname:=copy (path,1,j-1);
end;


Function Basename ( const path : pathstr; const suf : pathstr) : pathstr;

{

 This function returns the filename part of a complete path. If suf is supplied,
 it is cut off the filename.
}

var i,j : byte;
    snip : boolean;
    
begin
  if path='' then
     begin
     basename:='';
     exit
     end;
  { Copy from ?}
  j:=0;
  for i:=1 to length(path) do if path[i]='/' then j:=i;
  { Copy to ?}
  if suf='' then 
     i:=length(path)
  else
     begin
     snip:=true;
     for i:=1 to length(suf) do 
        if path[length(path)-length(suf)+i]<>suf[i] then snip:=false;
     if not snip then i:=length(path) else i:=length(path)-length(suf)
     end;
  if i<j then 
     basename:=''
  else
     basename:=copy (path,j+1,i-j)
end;



Function FNMatch(Var Pattern: PathStr; const Name: PathStr): Boolean;

{
  This function returns true if 'name' matches 'pattern', where pattern is any 
  wildcard construction consisting of '*' and '?'
  ( Needs extension ! )
} 

  Var
    ln: Byte;
    lp: Byte;

  Function DoFNMatch(i: Byte; j: Byte): Boolean;
    Var
      Temp: Boolean;

    Begin
    Temp := True;
    While (i <= lp) and Temp Do
      Begin
      Case pattern[i] of
        '?' : If j > ln then 
                temp:=false;
        '*' :
              Begin
              { find the next character in pattern, different of ? and * }
              inc(i);
              while  (i <= lp) and
              ((pattern[i] =' ?') or (pattern[i] = '*')) and temp do
                begin
                {if it is a ? and there is no more letter in name, it doesn't match}
                if (pattern[i]='?') and (j>ln) then 
                  temp:=false;
                { only increase j if it was a ? }
                if pattern[i]='?' then 
                  inc (j);
                inc (i);
                end;
              { Now, find in name the character which i points to, if the
                * or ? wasn't the last character in the pattern,
                else, use up all the chars in name }
              if i<=lp then
                begin
                repeat
                  begin
                  { find a letter (not only first !) which maches pattern[i] }
                  while (j<=ln) and (name[j]<>pattern[i]) do 
                    inc (j);
                  { if found, compare the rest }
                  if j<=ln then
                    begin
                    temp:=dofnmatch (i+1,j+1);
                    if temp then
                      begin
                      j:=ln+1; { We've found one, we can stop}
                      i:=lp+1
                      end
                    else
                      inc (j) {We didn't find one, need to look further}
                    end
                  else
                    { We didn't find a letter which matches, we can stop }
                    temp:=false;
                  end;
                until (j>ln) or temp;
                end
              else
                j:=ln+1
            end
          else { not a wildcard character in pattern }
            if (j>ln) or (pattern[i]<>name[j]) then 
              temp:=false
        end; { case }
      inc(i);
      inc(j);
      end; {while}
    { at this point, we've exhausted all characters in pattern, or
      we know the thing doesn't match }
    {if we still have unused chars in name, it doesn't match}
    if j<=length(name) then
      dofnmatch:=false
    else
      dofnmatch:=temp
    end;

  Begin {start FNMatch}
  lp := Length(Pattern);
  ln := Length(Name);
  FNMatch := DoFNMatch(1,1);
  End;

Procedure Globfree ( var p : pglob );

{ 
    Release memory occupied by pglob structure, and names in it.
    sets p to nil.
}  
  
var temp : pglob;

begin
  while p<>nil do
    begin
    temp:=p^.next;
    if p^.name<>nil then
       freemem (p^.name,strlen(p^.name));
    dispose (p);
    p:=temp
    end   
end;


       
Function Glob (const path : pathstr) : pglob;

{ 
  Fills a tglob structure with entries matching path, 
  and returns a pointer to it. Returns nil on error, 
  linuxerror is set accordingly.
}


var temp     : string[255];
    thedir   : pdir;
    buffer   : pdirent;
    root,run : pglob;
    
        
begin
  { Get directory }
  if dirname (path)='' then 
     temp:='.' 
  else
     temp:=dirname(path);
  temp:=temp+#0;
  thedir:=opendir (@temp[1]);
  if thedir=nil then 
     begin
     glob:=nil;
     linuxerror:=errno;
     exit
     end;
  temp:=basename(path,''); { get the pattern }
  if thedir^.fd<0 then
     begin
     linuxerror:=errno;
     glob:=nil;
     exit
     end;
  {get the entries}
  new (root);
  run:=root;
  repeat
    buffer:=sys_readdir (thedir);
    if buffer<>nil then
       begin
       if fnmatch (temp,strpas(@(buffer^.name[0]))) then
          begin
          { get memory for pglob }
          new(run^.next);
          if run^.next=nil then
             begin
             linuxerror:=sys_ENOMEM;
             globfree (root);
             glob:=nil;
             exit
             end
          else
             begin
             run:=run^.next;
             run^.next:=nil
             end;
          { Get memory for name }
          getmem (run^.name,strlen(@(buffer^.name[0]))+1);
          if run^.name=nil then 
             begin
             linuxerror:=sys_ENOMEM;
             globfree (root);
             glob:=nil;
             exit
             end;
          move (buffer^.name[0],run^.name^,strlen(@(buffer^.name[0]))+1 );
          end{ if fnmatch }
       end { buffer <> nil }   
    else 
       begin
       run:=root;
       if root^.next<>nil then root:=root^.next; { put root on first entry}
       if run<>nil then 
          begin
          run^.next:=nil;
          globfree (run)
          end
       end
  until buffer=nil;
  if root^.name=nil then 
     begin
     dispose (root);
     linuxerror:=0;
     glob:=nil
     end
  else
     glob:=root
end;

Procedure OpenPipe (var F : Text);

begin
{$ifdef debug}
  write ('OpenPipe called for fd ',textrec(f).handle,' with mode ');
  if textrec(f).mode=fmoutput then writeln ('Output') else writeln ('input');
{$endif}
  if (textrec(f).mode=fmoutput) then
     begin
     if textrec(f).userdata[1]<>P_OUT then textrec(f).mode:=fmclosed
     end
  else if textrec(f).mode=fminput then
       begin
       if textrec(f).userdata[1]<>P_IN then textrec(f).mode:=fmclosed
       end
  else
     textrec(f).mode:=fmclosed;
end;

Procedure IOPipe (var F : text);

begin
{$ifdef debug}
  write ('IOPipe called for fd ',textrec(f).handle,' with mode ');
  if textrec(f).mode=fmoutput then writeln ('Output') else writeln ('input');
{$endif}
   If textrec(f).mode=fmoutput then
      sys_write (textrec(f).handle,pchar(textrec(f).bufptr),textrec(f).bufpos)
   else if textrec(f).mode=fminput then
      textrec(f).bufend:=sys_read(textrec(f).handle,pchar(textrec(f).bufptr),textrec(f).bufsize);
   textrec(f).bufpos:=0;
end;

Procedure FlushPipe ( var F : Text);

begin
{$ifdef debug}
  writeln ('FlushPipe called with FD ',textrec(f).handle,'.');
{$endif}
  if (textrec(f).mode=fmoutput) and (textrec(f).bufpos<>0) then IOPipe (f);
  textrec(f).bufpos:=0;
end;


Procedure ClosePipe ( var F : text);

begin
{$ifdef debug}
  writeln ('ClosePipe called with FD ',textrec(f).handle,'.');
{$endif}
  textrec(f).mode := fmclosed;
  sys_close (textrec(f).handle);
end;

Procedure AssignPipe (var pipe_in, pipe_out : text);

{
  Sets up a pair of file variables, which act as a pipe. The first one can
  be read from, the second one can be written to.
  If the operation was unsuccesful, linuxerror is set.
}

var pip : tpipe;

begin
{ Get file descriptors }
  if sys_pipe (pip)<0 then
     begin
     linuxerror:=errno;
     exit
     end;
{$ifdef debug}
  writeln ('Pipe : got (',pip[1],',',pip[2],')');
{$endif}
{ Got descriptors - Set up input }
  Textrec(Pipe_in).Handle:= pip[1];
  Textrec(Pipe_in).userdata[1]:=P_IN;
  TextRec(Pipe_in).Mode := fmClosed;
  TextRec(Pipe_in).BufSize := SizeOf(TextBuf);
  TextRec(Pipe_in).BufPtr := @TextRec(pipe_in).Buffer;
  TextRec(Pipe_in).BufPos := 0;
{ Use standard functions for input }
  TextRec(Pipe_in).OpenFunc  := @OpenPipe;
  TextRec(Pipe_in).InOutFunc := @IOPipe;
  TextRec(Pipe_in).FlushFunc := @FlushPipe;
  TextRec(Pipe_in).CloseFunc := @ClosePipe;
{ No names for pipes }
  TextRec(Pipe_in).Name[0]   := #0;
{ set up output }
  Textrec(Pipe_out).Handle:= pip[2];
  Textrec(Pipe_out).userdata[1]:=P_OUT;
  TextRec(Pipe_out).Mode := fmClosed;
  TextRec(Pipe_out).BufSize := SizeOf(TextBuf);
  TextRec(Pipe_out).BufPtr := @TextRec(Pipe_out).Buffer;
  TextRec(Pipe_out).BufPos := 0;
{ Use standard functions for output }
  TextRec(Pipe_out).OpenFunc  := @OpenPipe;
  TextRec(Pipe_out).InOutFunc := @IOPipe;
  TextRec(Pipe_out).FlushFunc := @FlushPipe;
  TextRec(Pipe_out).CloseFunc := @ClosePipe;
{ No names for pipes }
  TextRec(Pipe_out).Name[0]   := #0;
end;

Procedure CloseP ( Var F : text);

 var dummy : longint; 
     pl    : ^longint;

begin
  sys_close (textrec(f).handle);
  { closed our side }
  { Now wait for the other side to finish - this appears to beneeded ?? }
  pl:=@(textrec(f).userdata[2]);
  dummy:=pl^;
  waitpid (dummy,nil,0); 
end;

Procedure POpen ( var F : text; Prog : String; rw : char );

{
Starts the program in 'Prog' and makes it's input or out put the
other end of a pipe. If rw is 'w' or 'W', then whatever is written to 
F, will be read from stdin by the program in 'Prog'. The inverse is true
for 'r' or 'R' : whatever the program in 'Prog' writes to stdout, can be
read from 'f'.
}

var pipi, pipo : text;
    pid : longint;
    pl  : ^longint;
    p,pp : ppchar;
    temp : string[255];

begin
  LinuxError:=0;
  rw:=upcase(rw);
  if (rw<>'R') and (upcase(rw)<>'W') then
     begin
     LinuxError:=sys_enoent;
     exit
     end;
  AssignPipe (pipi,pipo);
  rewrite (pipo);
  reset (pipi);
  if Linuxerror<>0 then exit;
  pid:=fork;
  if linuxerror<>0 then
     begin
     close (pipi);
     close (pipo);
     exit
     end;
  if pid=0 then
     begin
     { We're in the child }
     if rw='W' then
        begin
        close (pipo);
        dup2 (pipi,input);
        close (pipi);
        if linuxerror<>0 then
           halt(127);
        end
     else
        begin
        close (pipi);
        dup2 (pipo,output);
        close (output);
        if linuxerror<>0 then 
           halt(127)
        end;
     getmem(pp,sizeof(pchar)*3);
     temp:='/bin/sh'#0'-c'#0+prog+#0;
     pp^:=@temp[1];
     p:=pp+sizeof(pchar);
     p^:=@temp[9];
     p:=p+sizeof(pchar);
     p^:=@temp[12];
     execvp ('/bin/sh',pp,envp);
     halt(127);
     end
   else
     begin
     { We're in the parent }
     if rw='W' then
        begin
        close (pipi);
        f:=pipo;
        textrec(f).bufptr:=@textrec(f).buffer
        end
     else
        begin
        close (pipo);
        f:=pipi;
        textrec(f).bufptr:=@textrec(f).buffer
        end;
     {Save the process ID - needed when closing }
     pl:=@(textrec(f).userdata[2]);
     pl^:=pid;
     textrec(f).closefunc:=@CloseP
     end;
end;



Procedure AssignStream ( Var StreamIn, Streamout : text; const Prog : String);

{
Starts the program in 'To' and makes its input and output the
other end of two pipes, which are the stdin and stdout of a program specified
in 'Prog'.
streamout can be used to write to the program, streamin can be used to read
the output of the program. See the following diagram :

Parent          Child
  STreamout -->  Input
  Streamin  <--  Output
}

var pipi, pipo : array[0..1] of text;
    pid: longint;

begin
  LinuxError:=0;
  AssignPipe (pipi[0],pipo[0]);
  if Linuxerror<>0 then exit;
  AssignPipe (pipi[1],pipo[1]);
  if Linuxerror<>0 then exit;
  pid:=fork;
  if linuxerror<>0 then
     begin
     for pid:=0 to 1 do
       begin
       close(pipi[pid]);
       close(pipo[pid]);
       end;
     exit
     end;
  if pid=0 then
     begin
     { We're in the child }
     close(input);
     dup (pipi[1],input);
     if linuxerror<>0 then halt(127);
     close(output);
     dup (pipo[0],output);
     if linuxerror<>0 then halt(127);
     execl (Prog);
     halt (127)
     end
  else
     begin
     { we're in the parent}
     { Let's redraw the schedule :
          Parent      Child
          pipo[1] --> pipi[1]
          pipi[0] <-- pipo[0]
      }
     close(pipo[0]);
     dup(pipi[0],streamin);
     close(pipi[1]);
     dup(pipo[1],streamout);
     end;
end;




Function StdErrWrite ( Var f : textrec ) : integer;

Var
    i: Word;

Begin
  i:=sys_write (2,pchar(f.bufptr),f.bufpos);
  if i>0 then 
    F.BufPos := F.bufpos-i; { Should be zero !!}
  StdErrWrite := 0; 
end;

Function StdErrInOut ( Var f : textrec) : integer;

begin
  Case F.Mode of
     fmInput: StderrInOut := 0; { Cannot read from stderr }
     fmOutput: StderrInOut := StderrWrite(F);
     End;
End;

Function StdErrOpen(Var F: TextRec) : Integer;

Begin
  If F.Mode = fmoutput Then
    StdErrOpen := 0
  Else
    StdErrOpen := 5; { Can not read from stderr }
End;

Function StdErrClose ( Var F : textrec ) : integer;

begin
  F.Mode := fmClosed;
  StdErrClose := 0;
end;


Procedure LinuxExit;

{ 
 Close stderr.
}

begin
  Close (StdErr);
  exitproc:=oldexitproc;
end;

Begin
{ set up stderr  }
  OldExitProc:=ExitProc;
  ExitProc:=@LinuxExit;
  TextRec(StdErr).Handle     := 2;
  TextRec(StdErr).Mode       := fmOutput;
  TextRec(StdErr).Bufsize    := Sizeof(Textbuf);
  TextRec(stdErr).bufptr     := @(textrec(stderr).buffer);
  TextRec(StdErr).Bufpos     := 0;
  TextRec(StdErr).OpenFunc   := @stderropen;
  TextRec(StdErr).InOutFunc  := @stderrinout;
  TextRec(StdErr).FlushFunc  := @stderrwrite;
  TextRec(StdErr).CloseFunc  := @stderrclose;
{ Stderr has no name !! }
  TextRec(StdErr).Name[0]   := #0;
{  rewrite (stderr);
}
End.