{$Define LINUX}

{ These things are set in the makefile. }
{. $Define AOUT}
{$define NativeLinux}


{ This goes together with the makefile, where we only define nativelinux. }

{$ifndef nativelinux}
{$define crtlib}
{$endif}

Unit SysLinux;

Interface

{$I systemh.inc}
{$I heaph.inc}

{ defined already in systemh.inc
type
  ppchar = ^pchar;               }

var argc : longint;
    argv : ppchar;
    envp : ppchar;

Implementation

{$I system.inc}

Type
  PLongint = ^Longint;

{$ifdef crtlib}
Procedure _rtl_exit(l: longint); [ C ];
Function  _rtl_paramcount: longint; [ C ];
Procedure _rtl_paramstr(st: pchar; l: longint); [ C ];
Function  _rtl_open(f: pchar; flags: longint): longint; [ C ];
Procedure _rtl_close(h: longint); [ C ];
Procedure _rtl_write(h: longint; addr: longInt; len : longint); [ C ];
Procedure _rtl_erase(p: pchar); [ C ];
Procedure _rtl_rename(p1: pchar; p2 : pchar); [ C ];
Function  _rtl_read(h: longInt; addr: longInt; len : longint) : longint; [ C ];
Function  _rtl_filepos(handle: longint): longint; [ C ];
Procedure _rtl_seek(handle: longint; pos:longint); [ C ];
Function  _rtl_filesize(handle:longint): longInt; [ C ];
Procedure _rtl_rmdir(buffer: pchar); [ C ];
Procedure _rtl_mkdir(buffer: pchar); [ C ];
Procedure _rtl_chdir(buffer: pchar); [ C ];
{$endif}

{$ifdef nativelinux}
{$define SYS_LINUX }
{$i syscalls.pp }
{$endif}

Procedure Halt;
  Begin
  Do_Exit;
  {$ifdef crtlib}
  _rtl_exit(0);
  {$endif}
  {$ifdef nativelinux}
  Sys_Exit(0);
  {$endif}
  End;


Procedure Halt(ErrNum: Byte);
  Begin
  Do_Exit;
  {$ifdef crtlib}
  _rtl_exit(errnum);
  {$endif}
  {$ifdef nativelinux}
  Sys_exit(ErrNum);
  {$endif}
  End;


Function ParamCount: Longint;
  Begin
  {$ifdef crtlib}
  ParamCount := _rtl_paramcount;
  {$endif}
  {$ifdef nativelinux}
  Paramcount := argc-1
  {$endif}
  End;


Function ParamStr(l: Longint): String;
  Var
    b : Array[0..255] of Char;
    TmpStr: String[255];
{$ifdef nativelinux}
    i : longint;
    pp : ppchar;
{$endif}

  Begin
  {$ifdef nativelinux}
  if l>argc then
     begin
     paramstr:='';
     exit
     end;
  pp:=argv;
  i:=0;
  while (i<l) and (pp^<>nil) do 
    begin
    pp:=pp+4;
    i:=i+1
    end;
  move (pp^^,b[0],255);
  {$endif}
  {$ifdef crtlib}
  _rtl_paramstr(@b, l);
  {$endif}
  Move(b, TmpStr[1], 255);
  TmpStr[255] := #0;
  TmpStr[0] := #255;
  TmpStr[0] := Chr(Pos(#0, TmpStr) - 1);
  ParamStr := TmpStr;
  End;

{$ifdef nativelinux}
function getcwd : string;

var thisdir : stat;
    rootino,thisino,dotdotino : longint;
    rootdev,thisdev,dotdotdev : word;
    thedir,dummy : string[255];
    dirstream : pdir;
    d : pdirent;
    mountpoint : boolean;
    predot : string[255];

procedure dodispose (p : pdir);

begin
  dispose (p^.buf);
  dispose (p)
end;

begin
  thedir:='/'#0;
  if sys_stat(@thedir[1],thisdir)<0 then
     begin
     getcwd:='';
     exit
     end;
  rootino:=thisdir.ino;
  rootdev:=thisdir.dev;
  thedir:='.'#0;
  if sys_stat(@thedir[1],thisdir)<0 then
        begin
        getcwd:='';
        exit
        end;
  thisino:=thisdir.ino;
  thisdev:=thisdir.dev;
  { Now we can uniquely identify the current and root dir }
  thedir:='';
  predot:='';

  while not ((thisino=rootino) and (thisdev=rootdev)) do
    begin
    { Are we on a mount point ? }
    dummy:=predot+'..'#0;
    if sys_stat(@dummy[1],thisdir)<0 then
       begin
       getcwd:='';
       exit
       end;
    dotdotino:=thisdir.ino;
    dotdotdev:=thisdir.dev;
    mountpoint:=(thisdev<>dotdotdev);
    { Now, Try to find the name of this dir in the previous one }
    dirstream:=opendir (@dummy[1]);
    if dirstream=nil then
       begin
       getcwd:='';
       exit
       end;
    new(d);
    repeat
    d:=sys_readdir (dirstream);
    if (d<>nil) then
      begin
      if sys_stat(@dummy[1],thisdir)<0 then
        begin
        closedir (dirstream);
        dodispose (dirstream);
        getcwd:='';
        exit
        end;
      if mountpoint or (d^.ino=thisino) then
        begin
        dummy:=predot+'../'+strpas(@(d^.name[0]))+#0;
        if sys_stat (@(dummy[1]),thisdir)<0 then
          begin
          closedir (dirstream);
          dodispose (dirstream);
          getcwd:='';
          exit
          end;
        end
      end
    until (d=nil) or ((thisdir.dev=thisdev) and (thisdir.ino=thisino) );
    if closedir (dirstream)<0 then
       begin
       dodispose (dirstream);
       getcwd:='';
       exit
       end;
    if d=nil then
      begin
      dodispose (dirstream);
      getcwd:='';
      exit
      end;
    { At this point, d.name contains the name of the current dir}
    thedir:='/'+strpas(@(d^.name[0]))+thedir;
    thisdev:=dotdotdev;
    thisino:=dotdotino;
    predot:=predot+'../';
    { We don't want to clutter op the heap with DIR records... }
    dodispose (dirstream);
    end;
  { Now rootino=thisino and rootdev=thisdev so we've reached / }
  getcwd:=thedir
end;
{$endif}

procedure getdir(drivenr : byte;var dir : string);

begin
  {!! dummy at this moment, for libcrt}
  {$ifdef nativelinux}
  dir:=getcwd
  {$endif}
end;


Procedure Randomize;
  Begin
  {$ifdef nativelinux}
  randseed:=sys_time;
  {$endif}
  {$ifdef crtlib}
  _rtl_gettime(longint(@randseed));
  {$endif}
  End;


{ use standard heap management }
{$I heap.inc}


Procedure Do_Close(h: Longint);
  Begin
  {$ifdef crtlib}
  _rtl_close(h);
  {$endif}
  {$ifdef nativelinux}
  sys_close(h);
  {$endif}
  End;


Procedure FileCloseFunc(Var t: TextRec);
  Begin
  Do_Close(t.handle);
  End;


Function Open(f: pchar; flags: Longint): Longint;

{$ifdef nativelinux}
var oflags : longint;
{$endif}

  Begin
  {$ifdef crtlib}
  open := _rtl_open(f, flags);
  {$endif}
  {$ifdef nativelinux}
  { We do the conversion of filemodes here, concentrated on 1 place }
  if (flags and $100)=$100 then 
    oflags := Open_CREAT or Open_TRUNC
  else if (flags and $10)=$10 then
    oflags:=Open_CREAT or Open_APPEND
  else
    oflags := 0;
  case (flags and 3) of
    0: oflags := oflags or Open_RDONLY;
    1: oflags := oflags or Open_WRONLY;
    2: oflags := oflags or Open_RDWR;
  end;
  open := sys_open(f, oflags,438);
  {$endif}
  End;


Procedure DosErase(p: pchar);
  Begin
  {$ifdef crtlib}
  _rtl_erase(p);
  {$endif}
  {$ifdef nativelinux}
  sys_unlink(p);
  {$endif}
  End;


Procedure DosRename(p1: pchar; p2 : pchar);
  Begin
  {$ifdef crtlib}
  _rtl_rename(p1, p2);
  {$endif}
  {$ifdef nativelinux}
  sys_rename(p1, p2);
  {$endif}
  End;


Procedure DosWrite(h: Longint; Addr: LongInt; Len : Longint);
  Begin
  {$ifdef crtlib}
  _rtl_write(h, addr, len);
  {$endif}
  {$ifdef nativelinux} 
  sys_write(h, pchar(addr), len);
  {$endif}
  End;


Function DosRead(h: LongInt; Addr: LongInt; Len : Longint) : Longint;
  Begin
  {$ifdef crtlib}
  dosread := _rtl_read(h, addr, len);
  {$endif}
  {$ifdef nativelinux}
  dosread := sys_read(h, pchar(addr), len)
  {$endif}
  End;


Function DosFilePos(Handle: Longint): Longint;
  Begin
  {$ifdef crtlib}
  DosFilePos := _rtl_filepos(Handle);
  {$endif}
  {$ifdef nativelinux}
  DosFilePos := sys_lseek(handle, 0, Seek_Cur);
  {$endif}
  End;


Procedure DosSeek(Handle: Longint; Pos: Longint);
  Begin
  {$ifdef crtlib}
  _rtl_seek(Handle, Pos);
  {$endif}
  {$ifdef nativelinux}
  sys_lseek(handle, pos, Seek_set);
  {$endif}
  End;


Function DosFileSize(handle: Longint): Longint;

{$ifdef nativelinux}
var temp : longint;
{$endif}

  Begin
  {$ifdef crtlib}
  DosFileSize := _rtl_filesize(handle);
  {$endif}
  {$ifdef nativelinux}
  temp:=sys_lseek (handle,0,seek_cur);
  Dosfilesize:=sys_lseek (handle,0,Seek_End);
  sys_lseek (handle,temp,seek_set);
  {$endif}
  End;


Procedure FileOpenFunc(Var f : TextRec);
  Var
    b : Array[0..255] of Char;

  Begin
  move(f.name[1],b,length(f.name));
  b[length(f.name)]:=#0;
  f.inoutfunc:=@fileinoutfunc;
  f.flushfunc:=@fileinoutfunc;
  f.closefunc:=@fileclosefunc;
  Case f.Mode of
    fminput : f.handle := open(b, $000);  {fmReadOnly}
    fmoutput : f.handle := open(b,$101); {Create/fmWriteOnly}
    fmappend : begin
               f.handle := open(b,$11);  {Create/Append}
               f.mode:=fmoutput; {To fool write procedures}
               end;
    End;
  If integer(f.handle) <= 0 Then
    InOutRes := 2;
  End;


Function Eof(Var t: Text): Boolean;[iocheck];
  Begin
{$ifndef nativelinux}
  Eof:=DosFileSize(TextRec(t).Handle) <= DosFilePos(TextRec(t).Handle);
  If Eof Then
    Eof:=TextRec(t).BufEnd <= TextRec(t).BufPos;
{$else}
  { The previous method will NOT work on stdin and pipes or sockets. 
    So how to do it ? 
     1) Check if characters in buffer - Yes ? EOF=false;
     2) Read buffer full. If 0 chars read : EOF !
    Michael.
  }
  if TextRec(T).mode=fmclosed then  { Sanity check }
    begin
    Eof:=True;
    Exit;
    end;
  if (TextRec(T).BufPos < TextRec(T).BufEnd) then
    begin
    Eof:=False;
    Exit
    end;
  TextRec(T).BufPos:=0;
  TextRec(T).BufEnd:=DosRead(TextRec(T).Handle,longint(TextRec(T).BufPtr),TextRec(T).BufSize);
  If TextRec(T).BufEnd<0 then TextRec(T).BufEnd:=0;
  Eof:=TextRec(T).BufEnd=0;
{$endif}
  End;


Procedure ReWrite(Var f: File; l: Word);[iocheck];
  Var
    b : array[0..255] of char;

  Begin
  FileRec(f).Mode:=fmoutput;
  Move(FileRec(f).Name[1], b, Length(FileRec(f).Name));
  b[Length(FileRec(f).Name)]:=#0;
  FileRec(f).Handle := Open(b, $101); {Create/fmWriteOnly}
  FileRec(f).RecSize:=l;
  If Integer(FileRec(f).Handle) <= 0 Then
    InOutRes := 3;
  End;


Procedure Reset(Var f: File; l: Word);[iocheck];
  Var
    b : Array[0..255] of char;

  Begin
  Move(FileRec(f).Name[1], b, Length(FileRec(f).Name));
  b[Length(FileRec(f).Name)]:=#0;
  Case (FileMode And 3) of
    0 : FileRec(f).Mode:=fminput;
    1 : FileRec(f).mode:=fmoutput;
    2 : FileRec(f).mode:=fminout;
    End;
{  FileRec(F).Handle := Open(B, FileMode);}
  FileRec(F).Handle := Open(B, $000); 
  FileRec(f).RecSize := l;
  If Integer(FileRec(F).Handle) <= 0 Then
    InOutRes := 2;
  End;

Procedure ReWrite(Var f: File);[iocheck];
  Begin
  ReWrite(f, 128);
  End;


Procedure Reset(Var f: File);[iocheck];
  Begin
  Reset(f, 128);
  End;

{$ifdef typedfile }
    type untypedfile = file;

    procedure rewrite(var f : typedfile);[iocheck];

       begin
          rewrite(untypedfile(f),128);
       end;

    procedure reset(var f : typedfile);[iocheck];

       begin
          reset(untypedfile(f),128);
       end;

    procedure typedwrite(typesize : longint;var f : typedfile;var buf);[iocheck, public, alias : 'TYPED_WRITE'];

       var
          size : longint;

        begin
        {   if typesize > 0 then }
             doswrite(filerec(f).handle,longint(@buf),typesize);
        end;

    procedure typedread(typesize : longint;var f : typedfile;var buf);[iocheck, public, alias : 'TYPED_READ'];
      var
         result : longint;

      begin
         { if typesize > 0 then }
           result:=dosread(filerec(f).handle,longint(@buf),typesize);
      end;

{    procedure close(var f : typedfile);

      begin
         close(untypedfile(f));
      end;

    function filepos(var f : typedfile) : longint;
      begin
        filepos:=filepos(untypedfile(f));
      end;

    function filesize(var f : typedfile) : longint;
      begin
        filesize:=filesize(untypedfile(f));
      end;

    procedure seek(var f : typedfile;pos : longint);
      begin
         seek(untypedfile(f),pos);
      end;

    procedure erase(var f : typedfile);
      begin
         erase(untypedfile(f));
      end;

    procedure rename(var f : typedfile;const s : string);
      begin
         rename(untypedfile(f),s);
      end;

    function eof(var f : typedfile) : boolean;
      begin
        eof:=eof(untypedfile(f));
      end; }

{$endif typedfile }

Procedure BlockWrite(Var f: File; Var Buf; Count: Longint);[iocheck];
  Var
    p : pointer;

  Begin
  p := @buf;
  DosWrite(FileRec(f).Handle, Longint(p), Count*FileRec(f).RecSize);
  End;


procedure blockread(var f : file;var buf;count : longint;var result : longint);[iocheck];
  begin
  result:=dosread(filerec(f).handle,longint(@buf),
  count*filerec(f).recsize) div filerec(f).recsize;
  end;


Procedure BlockRead(Var f: File; Var Buf; Count: longint);[iocheck];
  var
    result : longint;

  begin
  blockread(f,buf,count,result);
  end;


function filepos(var f : file) : longint;[iocheck];
   begin
   filepos:=dosfilepos(filerec(f).handle) div filerec(f).recsize;
   end;


function filesize(var f : file) : longint;[iocheck];
  begin
  filesize:=dosfilesize(filerec(f).handle) div filerec(f).recsize;
  end;


function eof(var f : file) : boolean;[iocheck];
  begin
  eof:=filesize(f)<=filepos(f);
  end;


procedure seek(var f : file;pos : longint);[iocheck];
  begin
  dosseek(filerec(f).handle,pos*filerec(f).recsize);
  end;


procedure close(var f : file);[iocheck];
  begin
  if (filerec(f).mode<>fmclosed) then
    begin
    filerec(f).mode:=fmclosed;
    do_close(filerec(f).handle);
    end;
  end;


{
procedure dos_dirs(func: byte; name: pchar);
  begin
  end;
}


{
procedure _dir(func: byte; const s: string);
  var
    buffer : array[0..255] of char;

  begin
  move(s[1],buffer,length(s));
  buffer[length(s)]:=#0;
  dos_dirs(func,buffer);
  end;
}


Procedure MkDir(Const s: String);
  Var
    Buffer: Array[0..255] of Char;

  Begin
  Move(s[1], Buffer, Length(s));
  Buffer[Length(s)] := #0;
  {$ifdef crtlib}
  _rtl_mkdir(buffer);
  {$endif}
  {$ifdef nativelinux}
  sys_mkdir(buffer, 511);
  {$endif}
  End;


Procedure RmDir(Const s: String);
  Var
    Buffer: Array[0..255] of Char;

  Begin
  Move(s[1], Buffer, Length(s));
  Buffer[Length(s)] := #0;
  {$ifdef crtlib}
  _rtl_rmdir(buffer);
  {$endif}
  {$ifdef nativelinux}
  sys_rmdir(buffer);
  {$endif}
  End;


Procedure ChDir(Const s: String);
  Var
    Buffer: Array[0..255] of Char;

  Begin
  Move(s[1], Buffer, Length(s));
  Buffer[Length(s)] := #0;
  {$ifdef crtlib}
  _rtl_chdir(buffer);
  {$endif}
  {$ifdef nativelinux}
  sys_chdir(buffer);
  {$endif}
  End;


Begin
{ Initialize ExitProc }
ExitProc := nil;

{ Setup heap }
HeapOrg := GetHeapStart;
HeapPtr := HeapOrg;
_memavail := GetHeapSize;
HeapEnd := HeapOrg + _memavail;
HeapError := @GrowHeap;
Freelist := nil;

{ Setup stdin }
Assign(Input, 'stdin');
TextRec(Input).Handle := 0;
TextRec(Input).Mode := fminput;
TextRec(Input).InOutFunc := @FileInOutFunc;
TextRec(Input).FlushFunc := @FileInOutFunc;

{ Setup stdout }
Assign(Output, 'stdout');
TextRec(Output).Handle := 1;
TextRec(Output).Mode := fmoutput;
TextRec(Output).InOutFunc := @FileInOutFunc;
TextRec(Output).FlushFunc := @FileInOutFunc;

InOutRes:=0;

End.
